import { world, system } from '@minecraft/server'

system.afterEvents.scriptEventReceive.subscribe((event) => {
    const { id, message, sourceEntity, sourceType } = event;

    console.log(id); // wiki:test
    console.log(message); // Hello World
    console.log(sourceEntity); // Player object
    console.log(sourceType); // Entity
    if (event.id == 'deep_end:crag_lightning_attack' && sourceEntity.dimension.id == 'minecraft:the_end' && sourceEntity.isGliding == true) {
        const xDepth = Math.abs(sourceEntity.location.x)
        const yCoordMod = sourceEntity.location.y / 50
        const zDepth = Math.abs(sourceEntity.location.z)
        const velocity = sourceEntity.getVelocity()
        const velocityTotal = (Math.abs(velocity.x) + Math.abs(velocity.y) + Math.abs(velocity.z)) * 8
        if ((xDepth >= 3000 && xDepth <= 4500 && zDepth <= 4500) || (zDepth >= 3000 && zDepth <= 4500 && xDepth <= 4500)) {
            let directionRand = (Math.floor(Math.random() * 3) - 1)
            let cragKnockback = (Math.random() * ((4 + velocityTotal) - (-4 - velocityTotal)) + -4 - velocityTotal)
            let boltRun = Math.floor(Math.random() * 4)
            if (boltRun == 2) {
                sourceEntity.runCommandAsync(`execute as @s[m=!c] run summon deep_end:end_lightning ~ ~ ~ ~ ~ deep_end:tracker_lightning`)
            }
            if (boltRun == 1) {
                sourceEntity.runCommandAsync(`/playsound random.fuse @a[r=100] ~ ~ ~ 1 1.5 0.1`)
                sourceEntity.runCommandAsync(`/playsound mob.guardian.attack_loop @s[r=100] ~ ~ ~ 1 1.5 1`)
                sourceEntity.runCommandAsync(`execute as @s[m=!c] run summon deep_end:end_lightning ~ ~ ~ ~ ~ deep_end:tracker_lightning`)
            }
            sourceEntity.runCommandAsync(`/particle deep_end:end_lightning_warn ~ ~ ~`)
            sourceEntity.runCommandAsync(`/damage @s 3 fly_into_wall`)
            sourceEntity.runCommandAsync(`/particle minecraft:knockback_roar_particle ~ ~ ~`)
            sourceEntity.runCommandAsync(`/particle deep_end:conclusio_boom ~ ~ ~`)
            sourceEntity.runCommandAsync(`/camerashake add @s[m=!c] 0.05 1 rotational`)
            sourceEntity.runCommandAsync(`/playsound ambient.weather.lightning.impact @s[r=100] ~ ~ ~ 1 1.5 1`)
            sourceEntity.runCommandAsync(`/playsound armor.equip_leather @s[r=100] ~ ~ ~ 1.5 1.5 1.5`)
            sourceEntity.applyKnockback(0, 0, 0, 0)
            sourceEntity.applyKnockback(cragKnockback * (Math.floor(Math.random() * 3) - 1), cragKnockback * (Math.floor(Math.random() * 3) - 1), cragKnockback * (Math.floor(Math.random() * 3) - 1), (Math.random() * ((0 - yCoordMod / 2) - (-4 - yCoordMod)) + (-4 - yCoordMod)))
        }
    };
    if (event.id == 'deep_end:crag_lightning_retract' && sourceEntity.dimension.id == 'minecraft:the_end' && sourceEntity.isGliding == false)
        sourceEntity.runCommandAsync(`event entity @e[tag=deep_end:tracker_lightning,r=5] deep_end:despawn`);
});