import { world, system } from '@minecraft/server'
let structureList = ["heirsthrone_stairs", "heirsthrone_turnl", "heirsthrone_turnr", "heirsthrone_straight", "heirsthrone_descent"]

world.afterEvents.dataDrivenEntityTriggerEvent.subscribe(data => {

    const entities = world.getDimension("the_end").getEntities({ type: "deep_end:heirs_throne_jigsaw" })

    for (const entity of entities) {

        let randStructure = structureList[Math.floor(Math.random() * structureList.length)]
        const dimension = entity.dimension.id
        if (randStructure == "heirsthrone_turnl" || randStructure == "heirsthrone_turnr") {
            if (dimension == "minecraft:the_end" && entity.id == "deep_end:heirsthrone_jigsaw") {
                if (randStructure == "heirsthrone_turnl") {
                    structureList = ["heirsthrone_stairs", "heirsthrone_turnr", "heirsthrone_straight", "heirsthrone_descent"]
                    entity.runCommandAsync(`say ROTATION SWAP SUCCESSFUL, R ENABLED. ${structureList}`)
                } else if (randStructure == "heirsthrone_turnr") {
                    structureList = ["heirsthrone_stairs", "heirsthrone_turnl", "heirsthrone_straight", "heirsthrone_descent"]
                    entity.runCommandAsync(`say ROTATION SWAP SUCCESSFUL, L ENABLED. ${structureList}`)
                }
            }
        }
        function switchRotationPieces() {
            if (randStructure == "heirsthrone_turnl" || randStructure == "heirsthrone_turnr") {
                if (randStructure == "heirsthrone_turnl") {
                    structureList = ["heirsthrone_stairs", "heirsthrone_turnr", "heirsthrone_straight", "heirsthrone_descent"]
                    entity.runCommandAsync(`say ROTATION SWAP SUCCESSFUL, R ENABLED. ${structureList}`)
                } else if (randStructure == "heirsthrone_turnr") {
                    structureList = ["heirsthrone_stairs", "heirsthrone_turnl", "heirsthrone_straight", "heirsthrone_descent"]
                    entity.runCommandAsync(`say ROTATION SWAP SUCCESSFUL, L ENABLED. ${structureList}`)
                }
            }
        }
        const entityRotation = Math.floor(entity.getRotation().y)
        entity.runCommandAsync(`say ROTATION IS ${entityRotation}`)
        const locationX = entity.location.x
        const locationY = entity.location.y
        const locationZ = entity.location.z

        if (entityRotation == 0) {
            if (randStructure == "heirsthrone_stairs" || randStructure == "heirsthrone_descent") {
                entity.runCommandAsync(`execute as @s at @s if block ^1 ^ ^1 air run structure load ${randStructure} ^ ^-8 ^1`)
            } else {
                entity.runCommandAsync(`execute as @s at @s if block ^1 ^ ^1 air run structure load ${randStructure} ^ ^ ^1`)
            }
            entity.runCommandAsync(`say ${randStructure} ${entityRotation}. Z coordinate ${locationZ}`)
            entity.runCommandAsync(`say ${structureList}`)
            switchRotationPieces()
            entity.runCommandAsync(`kill @s`)
        } else if (entityRotation == 90) {
            if (randStructure == "heirsthrone_stairs" || randStructure == "heirsthrone_descent") {
                entity.runCommandAsync(`execute as @s at @s if block ^1 ^ ^1 air run structure load ${randStructure} ^ ^-8 ^9 90_degrees`)
            } else {
                entity.runCommandAsync(`execute as @s at @s if block ^1 ^ ^1 air run structure load ${randStructure} ^ ^ ^9 90_degrees`)
            }
            entity.runCommandAsync(`say ${randStructure} ${entityRotation}. Z coordinate ${locationZ}`)
            switchRotationPieces()
            entity.runCommandAsync(`kill @s`)
        } else if (entityRotation == -90) {
            if (randStructure == "heirsthrone_stairs" || randStructure == "heirsthrone_descent") {
                entity.runCommandAsync(`execute as @s at @s if block ^1 ^ ^1 air run structure load ${randStructure} ^8 ^-8 ^1 270_degrees`)
            } else {
                entity.runCommandAsync(`execute as @s at @s if block ^1 ^ ^1 air run structure load ${randStructure} ^8 ^ ^1 270_degrees`)
            }
            entity.runCommandAsync(`say ${randStructure} ${entityRotation}. Z coordinate ${locationZ}`)
            switchRotationPieces()
            entity.runCommandAsync(`kill @s`)
        } else if (entityRotation == -180) {
            if (randStructure == "heirsthrone_stairs" || randStructure == "heirsthrone_descent") {
                entity.runCommandAsync(`execute as @s at @s if block ^1 ^ ^1 air run structure load ${randStructure} ^8 ^-8 ^9 180_degrees`)
            } else {
                entity.runCommandAsync(`execute as @s at @s if block ^1 ^ ^1 air run structure load ${randStructure} ^8 ^ ^9 180_degrees`)
            }
            entity.runCommandAsync(`say ${randStructure} ${entityRotation}. Z coordinate ${locationZ}`)
            switchRotationPieces()
            entity.runCommandAsync(`kill @s`)
        }
        if (randStructure != "heirsthrone_end") {
            entity.runCommandAsync(`event entity @e[type=deep_end:heirs_throne_jigsaw,r=50,rm=0.01] deep_end:fake_event`)
            entity.runCommandAsync(`say ${structureList}`)
        } else if (dimension == "minecraft:the_end" && entity.id == "deep_end:heirsthrone_jigsaw") {
            entity.runCommandAsync(`kill @s`)
        }
        if (entity) {
            entity.runCommandAsync(`kill @s`)
            entity.runCommandAsync(`say END OF SCRIPT EXECUTED`)
        }
        for (let i = 0; i < structureList.length; i++) {
            if (structureList[i] == "heirsthrone_end") {
                structureList.splice(i, 1)
            }
        }
        if (entity.location.y <= 15) {
            structureList.push("heirsthrone_end")
        } else {
            for (let i = 0; i < structureList.length; i++) {
                if (structureList[i] == "heirsthrone_end") {
                    structureList.splice(i, 1)
                }
            }
        }
    }
}
)